--[[
Seasonal Prices adds seasonal variation to the prices of various products, both when buying and selling. 

Author:     w33zl
Version:    1.0.0
Modified:   2024-06-17

Changelog:

]]

-- Init the mod using the "mod bootstrapper" from WeezlsModLib. Check https://github.com/w33zl/FS22_WeezlsModLib for details about the "Mod" class

local SeasonalPrices = Mod:init()
_G.SeasonalPrices = SeasonalPrices

local ENABLE_BUYSTATION = true

if ENABLE_BUYSTATION then

    Log:debug("Seasonal prices at buying station enabled")

    BuyingStation.getEffectiveFillTypePrice = Utils.overwrittenFunction(BuyingStation.getEffectiveFillTypePrice, function(self, superFunc, fillTypeIndex)
        local pricePerLiter = superFunc(self, fillTypeIndex)
        local period, alpha = g_currentMission.environment:getPeriodAndAlphaIntoPeriod()
        local seasonalPriceFactor = g_currentMission.economyManager:getFillTypeSeasonalFactor(g_fillTypeManager:getFillTypeByIndex(fillTypeIndex), period, alpha)

        --TODO: add factor for game difficulty?
        --TODO: add random factor per buy station

        return pricePerLiter * seasonalPriceFactor
    end)
end
